/*****************************************************************************
* CAITF.H
*
* (C) Copyright 1998 Rainbow Technologies, Inc. All rights reserved.
*
* Description : Used to launch the Client Activator.
******************************************************************************/
#ifndef CaItfH
#define CaItfH
#include <windows.h>
#include "CaStatus.h"

#define MAX_PATH_LEN         512
// Try Button values
#define DISABLE_TRY_BUTTON   0 // disables the try button
#define ENABLE_TRY_BUTTON    1 // shows as "Try"
#define ENABLE_REGISTER_DEMO 2 // Shows as "Register Demo"

// ASCII version for ClientActivatorA API
typedef struct _CA_ACTIVATOR_INFOA {

   /* Size of this record */
   DWORD size;

	/* Parent window handle, or NULL */
   DWORD wndHandle;

   /* spawn and wait flag 1 = spawn and wait, 0 = just spawn, don't wait */
   LONG  spawnAndWait;

	/* 1 = Display Try button*/
   LONG  enableTryButton;

	/* Number of trial days left. -1 = ignore */
   LONG  daysLeft;

	/* Number of executions left. -1 = ignore */
   LONG executionsLeft;

	/* Execution time left in minutes. -1 = ignore */
   LONG  minutesLeft;

	/* >0 = inhibits installation of licenses when a config */
   LONG  disableLicInstall;

   /* Full path of config file */
   char configFile[MAX_PATH_LEN];

} CA_ACTIVATOR_INFOA, FAR *PCA_ACTIVATOR_INFOA;

// Wide char version for ClientActivatorW API
typedef struct _CA_ACTIVATOR_INFOW {

   /* Size of this record */
   DWORD size;

	/* Parent window handle, or NULL */
   DWORD wndHandle;

   /* spawn and wait flag 1 = spawn and wait, 0 = just spawn, don't wait */
   LONG  spawnAndWait;

	/* 1 = Display Try button*/
   LONG  enableTryButton;

	/* Number of trial days left. -1 = ignore */
   LONG  daysLeft;

	/* Number of executions left. -1 = ignore */
   LONG  executionsLeft;

	/* Execution time left in minutes. -1 = ignore */
   LONG  minutesLeft;

	/* >0 = inhibits installation of licenses when a config */
   LONG  disableLicInstall;

   /* Full path of config file */
   wchar_t configFile[MAX_PATH_LEN];

} CA_ACTIVATOR_INFOW, FAR *PCA_ACTIVATOR_INFOW;

#ifdef UNICODE
typedef  CA_ACTIVATOR_INFOW  CA_ACTIVATOR_INFO;
typedef PCA_ACTIVATOR_INFOW PCA_ACTIVATOR_INFO;
#else
typedef  CA_ACTIVATOR_INFOA  CA_ACTIVATOR_INFO;
typedef PCA_ACTIVATOR_INFOA PCA_ACTIVATOR_INFO;
#endif
#ifdef __cplusplus
extern "C" {
#endif
LONG WINAPI ClientActivatorA( PCA_ACTIVATOR_INFOA p_actInfo );
LONG WINAPI ClientActivatorW( PCA_ACTIVATOR_INFOW p_actInfo );
#ifdef UNICODE
#define ClientActivator ClientActivatorW
#else
#define ClientActivator ClientActivatorA
#endif
#ifdef __cplusplus
};
#endif
#endif
// end of file
