/* license.c */

#define SENTINEL 	/* if Sentinel keys have to be used; for standalone in file "lservrc" */
#define noLICENSE_CREATION_noSentinel 	/* if a license keyfile "revxml.lic" has
																						   to be generated in the noSentinel case */

#if defined(WINDOWS) || defined(WIN32)
#  include <windows.h>
#endif
#include <stdlib.h>
#include <stdio.h>

#include <string.h>
#include <time.h>
#include "lserv.h"   /* header file for SentinelLM    */
#include "vintlstr.h"
#include "caitf.h"
#include "revxml.h"

/* SentinelLM variables and defines */

#define FEATURE "10" /* 10 */
#define VERSION ""

#if defined(unix)
#  define FALSE 0
#  define TRUE  1
#endif

char buffer_sprintf[255];	/* buffer for printing messages */
long result;

#ifdef SENTINEL
LS_HANDLE handle_p = 0;




/*F****************************************************************
*
* DESCRIPTION     :
*           This function handles error condition of type errCode.
*
* NOTES           :
*/

LS_STATUS_CODE VMSWINAPI
#ifdef __V_STDC__
HandlerHook4(LS_STATUS_CODE errCode, char LSFAR *fname)
#else
HandlerHook4(errCode, fname)
LS_STATUS_CODE  errCode; /* IN */
char            *fname;  /* IN - This is not used but error handling
                                 routines must have this prototype */
#endif
/*F*/
{
    /* fprintf(LM_STDERR, VL10N_LSM_ERR_LSHOST_01_STR);
    fprintf(LM_STDERR, VL10N_LSM_ERR_LSHOST_02_STR); */
    return(errCode);
}

#ifdef __V_STDC__
HandlerHook17(LS_STATUS_CODE errCode, char LSFAR *fname)
#else
HandlerHook17(errCode, fname)
LS_STATUS_CODE  errCode; /* IN */
char            *fname;  /* IN - This is not used but error handling
                                 routines must have this prototype */
#endif
/*F*/
{
    /* fprintf(LM_STDERR, VL10N_LSM_ERR_LSHOST_01_STR);
    fprintf(LM_STDERR, VL10N_LSM_ERR_LSHOST_02_STR); */
    return(errCode);
}





long RunActivator( HWND hWnd, char *configFile )
{
    CA_ACTIVATOR_INFOA Info;
    memset( &Info, 0, sizeof(Info) );
    Info.size    = sizeof(Info);
    Info.wndHandle = (long)hWnd;
    Info.enableTryButton = ENABLE_REGISTER_DEMO /* ENABLE_TRY_BUTTON, DISABLE_TRY_BUTTON */;
    Info.spawnAndWait = 1;
    strcpy( Info.configFile, configFile );
    return( ClientActivatorA( &Info ) );
}

long checkLicense_Sentinel()
{
#define RAC_FILE_NAME "RevXml Demo.rac"
#define PATH_SAPERATOR "\\"
  char serverName[MAXLEN];
	char CurrentDir[_MAX_PATH] = "";
	char CurrentDir_0[_MAX_PATH] = "";
  char AbsolutePath[_MAX_PATH + 20] = "";

  LS_STATUS_CODE rc;

  /* ***** Modifications made by Rainbow - START ***** */
  char *tmpStr = NULL;
  /* ***** Modifications made by Rainbow - END ***** */

	/* struct feature_info_struct finfo; */
	LONG WINAPI IsAwInstalled (LONG languageType);

/* #define TRACE_api */
#ifdef TRACE_api
	VLSsetTraceLevel(VLS_TRACE_ALL);
#endif

	 /* Turn default error handling off */
	 rc = VLSerrorHandle(VLS_OFF);  /* always returns LS_SUCCESS */

		/* Change default behavior of popping up Message Boxes on Windows */
		VLSsetUserErrorFile(VLS_NULL, NULL);
		/* Override error handling */
		VLSsetErrorHandler(HandlerHook4, (LS_STATUS_CODE) VLS_NO_SERVER_FILE);
		VLSsetErrorHandler(HandlerHook17, (LS_STATUS_CODE) VLS_NO_RESPONSE_TO_BROADCAST);

	 /* Prepare to use SentinelLM */
   rc = VLS_INITIALIZE ();
   if (rc != LS_SUCCESS)
	 { /* error */ ;
		 /* Cleanup after using SentinelLM */
		 VLS_CLEANUP ();
     return rc;
   }

   //VLSdisableLocalRenewal(); /* SentinelLM API call for key renewal */
   //VLSsetServerPort(5093);
   //VLSdisableAutoTimer( 0, VLS_OFF );

   /* Request key from SentinelLM license manager */
   rc = VLS_REQUEST(FEATURE, VERSION, &handle_p);
   if (rc != LS_SUCCESS)
	 {
		/* Cleanup after using SentinelLM */
     VLS_CLEANUP ();
		 /* Run Client Activator */
#ifdef Unclear
		 /* Check first if it is present */
		 rc = IsAwInstalled(1 /*LOCAL_ENGLISH*/);
		 if (rc == 0)
		 {  /* not installed */ /* to do something here */
		 }
#endif

    /* 	GetSystemDirectory(CurrentDir, _MAX_PATH); delivers C:WINNT\System32 */
		/* GetCurrentDirectory(_MAX_PATH, CurrentDir_0); == path where the executable was called */

    /* ***** Modifications made by Rainbow - START ***** */

    GetModuleFileName(NULL, CurrentDir, _MAX_PATH);/* path where the executable is residing */

    /* remove the executable name and append the name of .rac file */
    tmpStr = strrchr(CurrentDir, '\\');
    if(NULL == tmpStr) {
       /* There is some problem, quit */
       return 1;
    }
    tmpStr[0] = '\0';

    /* ***** Modifications made by Rainbow - END ***** */

    strcpy(AbsolutePath, CurrentDir);
    strcat(AbsolutePath, PATH_SAPERATOR);
    strcat(AbsolutePath, RAC_FILE_NAME);

    rc = RunActivator(NULL, AbsolutePath);

		return rc;
   }

/*#define GETFEATURE*/ /* should not be necessary for RevXml which has only one feature */
#if defined GETFEATURE
   /* Fill the size parameter of featureInfo struct.
    * Query may not get complete data otherwise.
    */
   finfo.structSz = sizeof(finfo);
	 rc = VLSgetFeatureInfo((unsigned char LSFAR *) FEATURE,
													(unsigned char LSFAR *) VERSION, 0, NULL, &finfo);
   if (rc != VLS_NO_MORE_FEATURES)
	 { /* error */
     /* Cleanup after using SentinelLM */
     VLS_CLEANUP ();
     return rc;
   }
	 else
	 {  /* if there is a networkversion the minimum number of licenses should be 5 */
			if (finfo.is_standalone == VLS_FALSE)
			{
				if (finfo.num_licenses < 5)
				  return -finfo.num_licenses;
			}
	 }
#endif

   VLSerrorHandle(VLS_OFF);
   /*
    * Get the name of the server we are talking to so we can display
    * it in the title bar.
    */
   rc = VLSgetServerNameFromHandle(handle_p, (char LSFAR *) serverName,
              sizeof(serverName));
   if (rc != LS_SUCCESS)
	 { /* It's not fatal. Just say we don't know. */
     strcpy(serverName, "UNKNOWN");
	 }
   /* Cleanup after using SentinelLM */
   VLS_CLEANUP ();
   return LS_SUCCESS;
} /* End of checkLicense_Sentinel */

#endif /* SENTINEL */


#ifndef SENTINEL

/* === Former utility for simple license keys ===
To be used in case Sentinel keys do not work */

/*
     Compile with the preprocessor LICENSE_CREATION defined to obtain a command
     line utility that can be used to create a license file.
*/
/* #define LICENSE_CREATION_noSentinel
   Commented out by PCM: it should be passed as a compiler option, not within the code.
   Pass LICENSE_CREATION only if you want to make an executable (with a main() method.
   In other cases, do not pass it, because otherwise conflicts with other main methods
   may arise.
   PCM 2001.03.12
*/
#define USAGE "licensing [yyyy mm dd]"

#include <time.h>
#include <stdlib.h>
#include <stdio.h>

#include "licensing.h"

#define GARBAGE     1024


#define YEARPOS     111
#define MONTHPOS    222
#define DAYPOS      333
#define VERSIONPOS  777

#define YEARFACTOR  444
#define MONTHFACTOR 555
#define DAYFACTOR   666
#define VERSION_noSentinel     1

long readLicense_noSentinel(char *pathname, long *year, long *month, long *day)
{
	long garbage[GARBAGE];
	FILE *f;
	long result;
	*year = 0L; *month = 0L; *day = 0L;

	f = fopen(pathname, "rb");

	if (f == NULL)
	{
		result = no_license_file;
	}
	else
	{
		size_t len = fread(garbage, sizeof(long), GARBAGE, f);
		fclose(f);

		if (len == GARBAGE)
		{
			long y, m, d;

			if (garbage[VERSIONPOS] == VERSION_noSentinel)
			{
				y = (long)(garbage[YEARPOS] / YEARFACTOR);
				m = (long)((garbage[MONTHPOS] - y) / MONTHFACTOR);
				d = (long)((garbage[DAYPOS] - m) / DAYFACTOR);
				*year = y; *month = m; *day = d;
			}
		};
		result = 0;
	};
	return result;
} /* end readLicense_noSentinel */


long checkLicense_noSentinel(char *pathname, long *lic_year, long *lic_month, long *lic_day)
{
   time_t curTime;
	 struct tm *timestruct;
	 long cur_year, cur_month, cur_day;

   time(&curTime);
   timestruct = gmtime(&curTime);
   cur_day = timestruct->tm_mday;    /* 1 <= tm_mday <= 31 */
   cur_month = timestruct->tm_mon+1; /* 0 <= tm_mon <= 11 */
   cur_year = timestruct->tm_year + 1900;

   result = readLicense_noSentinel(pathname, lic_year, lic_month, lic_day);
   /* Note: year, month and day are 0 if an error occurs. */

   if (result == no_license_file)
	 {
		 return result;
	 }
	 else
   {    long now_absolute = ((cur_year-1990) * 366) + (cur_month * 12) + cur_day;
        long lic_absolute = ((*lic_year-1990) * 366) + (*lic_month * 12) + *lic_day;
        return (now_absolute > lic_absolute);
   }
} /* checkLicense_noSentinel */
#endif /* SENTINEL */

long checkLicense(char* buffer_sprintf, char* lic_filename)

#ifdef SENTINEL
{
	result = checkLicense_Sentinel();
	if (result != LS_SUCCESS)
	{
		switch (result)
		{ case CA_NOT_INSTALLED: strcpy(buffer_sprintf, "The Client Activator is not installed (.rac file missing).");
				break;
			case CA_SPAWN_ERROR: strcpy(buffer_sprintf, "Error in spawning Client Activator.");
				break;
			case CA_TRIAL_EXECUTION: strcpy(buffer_sprintf, "Within Client Activator: try button or fax/mail activation used.");
				break;
			case CA_MORE_THAN_1_INSTANCE: strcpy(buffer_sprintf, "Error: more than one instance of the Client Activator is running.");
				break;
			case CA_USER_CANCELED: strcpy(buffer_sprintf, "User quited Client Activator before retrieving a license.");
				break;
			default: sprintf(buffer_sprintf, "Unknown error in running Client Activator, error code is %d ", result);
				break;
		}
	}
#endif

#ifndef SENTINEL
{
	long year, month, day, result;
	/* readLicense(LICENSE_FILE, &year, &month, &day); == dubbel op == */
	result = checkLicense_noSentinel(lic_filename, &year, &month, &day);
	if (result == no_license_file)
	{
    sprintf(buffer_sprintf, "No license file Revxml.lic found");
	}
	else
	if (result != 0)
	{
    sprintf(buffer_sprintf, "Your license expired at %ld-%ld-%ld (d-m-y)", day, month, year);
		result = license_expired;
	}
#endif

	return result;
} /* checklicense */


#ifndef SENTINEL
#ifdef LICENSE_CREATION_noSentinel

static
void makeLicenseFile_noSentinel(char *pathname,
                     long year, long month, long day) {
     long garbage[GARBAGE];

#if defined(WINDOWS) || defined(WIN32)
		 srand((unsigned)time(NULL));
     { int i; for (i = 0; i < GARBAGE; i++) garbage[i] = rand(); }
#else
     srandom((unsigned)time(NULL));
     { int i; for (i = 0; i < GARBAGE; i++) garbage[i] = random(); }
#endif

     garbage[YEARPOS]    = year * YEARFACTOR;
     garbage[MONTHPOS]   = year + (month * MONTHFACTOR);
     garbage[DAYPOS]     = month + (day * DAYFACTOR);

     garbage[VERSIONPOS] = VERSION_noSentinel;

     {    FILE *f = fopen(pathname, "wb");
          fwrite(garbage, sizeof(long), GARBAGE, f);
          fclose(f);
	 }
} /* end makeLicenseFile_noSentinel */

//int main(int argc, char *argv[])
int WINAPI WinMain(hInstance, hPrevInstance, lpCmdLine, nCmdShow)
HINSTANCE  hInstance;
HINSTANCE  hPrevInstance;
LPSTR lpCmdLine;
int nCmdShow;
{
	 if (argc == 1)
	 {
			long year, month, day;
			result = readLicense_noSentinel(LICENSE_FILE, &year, &month, &day);

			if (result == no_license_file)
			{
				fprintf(stdout, "No license file Revxml.lic found");
				return result;
			}

			fprintf(stdout, "Expiration: %lu-%lu-%lu\n", year, month, day);
			if (checkLicense_noSentinel(LICENSE_FILE, &year, &month, &day))
			{
				fprintf(stdout, "License has expired\n");
			} else
			{
				fprintf(stdout, "License is valid\n");
			}
	 }
	 else
	 {
			if (argc != 4)
			{
				 fprintf(stderr, "%s\n", USAGE);
			}
			else
			{
				 long year, month, day;
				 year = atol(argv[1]);
				 month = atol(argv[2]);
				 day = atol(argv[3]);

				 makeLicenseFile_noSentinel(LICENSE_FILE, year, month, day);
				 fprintf(stdout, "run %s without arguments as a check\n", argv[0]);
			}
	 }
	 return EXIT_SUCCESS;
}
#endif /* LICENSE_CREATION_noSentinel */

#endif /* noSENTINEL */
