/* #define _UNICODE */

/* #define BATCH_mode */

/* #define tight_revisionmarkers */	
		 /* when this switch is on:
				if atomic_unit_of_text == rev_words 
				the revision markers are written as close to a word as 
				possible */
#define mallocs_from_array
		 /* when this switch is on: mallocs are taken from the previous 
			  allocated array alloc_base; this speeds up the process considerably */   

/* Exporting functions is done very differently in Windows and Windows NT! */
#ifdef WIN32
#define DllExport(p) 	__declspec ( dllexport ) p
#elif defined(WINDOWS)
#define DllExport(p)	p FAR PASCAL _export 
#else
/* On other platforms, no export is done at all */
#define DllExport(p)	p
#endif
                                 
/* return codes of revxml which will be returned to the calling program */
#define not_enough_memory_on_heap (1)
#define not_enough_memory_for_d (2)
#define no_corresponding_starttag (3)
#define not_positioned_at_equalsign (4)
#define hashed_text_too_long (5)
#define name_too_long (6)
#define unequal_lengths_of_rev_markers (7)
#define file_not_opened (8)
#define combtags_and_printa_both_true (9)
#define file_buffer_too_small	(10)
#define cr_data_buffer_too_small (11)
#define switches_not_correct (12)
#define too_many_names (13)
#define heapsize_too_large (14)
#define license_expired (15)
#define compared_with_buffer_too_small (16)
#define increase_pagesize (17)
#define error_in_emp_file (18)
#define no_license_file (19)
#define value_of_d_out_of_range (20)
/* end of status codes */

/* atomic units of text on which revision detection takes place */
#define rev_chars (1)
#define rev_words (2)
#define rev_sentences (3)
#define rev_pcdata (4)
/* end of atomic units of text on which revision detection takes place */

#define inputline_size (20000)
#define max_outputline_size (20000)
#define max_compared_with_buffer_size (60000) /* compared_with_buffer will be overlayed within a page in the cache;
	therefore, max_compared_with_buffer_size should be larger than cache_page_size */

#define true (1)
#define false (0)

FILE *tracefile;  /* used for the trace file */
FILE *logfile;  /* used for the 'log' file */

void error_file_open(FILE *openfile, char *filename, long *result);

void get_switch_from_deffile(char *sw);

void read_switches(long *result);

DllExport(void) revxml_on_buffers(long in_data_a,			/* pointer to old text */
				  long in_len_a,			/* length of old text */
				  long in_data_b,			/* pointer to new text */
				  long in_len_b,			/* length of new text */
				  long in_data_c,			/* pointer to text with revision markers */
				  long *return_len_c,			/* length of text with revision markers */

				  long *in_cr_data,			/* array which contains the positions of the cr's in data_b */
				  long in_cr_data_len,			/* length of the array cr_data */
				  long *eol_char_param,			/* end of line character on current platform */
				  char *filename_def_param, 		/* filename of file with settings, by default "revxml.def" */
				  char *filename_emp_param, 		/* filename of file with empty elements and discriminative 
																		 attributes, by default "revxml.emp" */
				  char *filename_log_param, 		/* filename of logfile */
				  char *filename_lic_param, 		/* filename of license file */
				  char *return_message,		        /* string with message after abnormal termination */
				  long eol_proc_param,			/* boolean: true if end-of-lines in file B should be kept in file C */
				  long	*return_error_code	        /* error code after abnormal termination */
                                 );
typedef void (*revxml_on_buffers_type)(long, long, long, long, long, long*, long*, long,
                                       char*, char*, char*, char*, char*, long, long);

DllExport(void) revxml_on_files(char *filename_a,			/* filename of old text */
				char *filename_b,			/* filename of new text */
				char *filename_c,			/* filename of text with rev markers */
				char *filename_def_param, 		/* filename of file with settings, by default "revxml.def" */
				char *filename_emp_param, 		/* filename of file with empty elements and discriminative 
																	       attributes, by default "revxml.emp" */
				char *filename_log_param, 		/* filename of logfile */
				char *filename_lic_param, 		/* filename of license file */
				char *return_message,	                /* string with message after abnormal termination */
				long eol_proc_param,			/* boolean: true if end-of-lines in file B should be kept in file C */
				long *return_error_code		        /* error code after abnormal termination */
                               );
typedef void (*revxml_on_files_type)(char*, char*, char*, char*, char*, char*, char*, char*, long, long*);
